// Includes
#include <PA9.h>       // Include for PA_Lib

#include "gfx/all_gfx.c"

#define COMBOTIME 40

typedef struct{
   s32 fx, fy, x, y, vx, vy;
   u8 type;
} ball_type;

typedef struct{
   u8 x, y, width;
} carre_type;   
carre_type carres[32];
u8 ncarres = 0;

#define MAX_BALLS 128
ball_type balls[MAX_BALLS]; // 100 max
u8 nball[MAX_BALLS];
u8 nlibre[MAX_BALLS];
u8 nballs;

u16 carregfx;
u16 ballgfx[2][3];
u16 sparkgfx;

u8 combo;
u8 combodown;

u8 lost = 0;
u8 level = 0;
s32 score = 0;

extern u16 nsparks;
void InitSparks(void);
s8 Deplacerspark(u16 i);
void Ajouterspark(u8 color, u8 number, s16 x, s16 y);

		
void AjouterCarre(void){

   carres[ncarres].x = 32+(PA_Rand()%(192));
   carres[ncarres].y = 32+(PA_Rand()%(128));   
   carres[ncarres].width = 0;
   PA_3DCreateSpriteFromTex(128+ncarres, carregfx, 16, 16, 0, carres[ncarres].x, carres[ncarres].y);
   PA_3DSetSpriteWidthHeight(128+ncarres, 0, 0);
   
   ncarres++;
   
}   


void UpdateColor(void){
	s16 r, g, b; u16 tempcombo = combo*2;
	r = tempcombo; if(r > 31) r = 31;
	g = tempcombo - 32; if(g < 0) g = 0; if(g > 31) g = 31;
	b = tempcombo - 64; if(b < 0) b = 0; if(b > 31) b = 31;			
	PA_SetBgPalCol(1, 0, PA_RGB(r, g, b));	

}   


s8 DeplacerBall(u8 i){
   u8 n = nball[i];
 //  s16 x, y;
   
   // Ajust l'angle...
   u16 angle = PA_GetAngle(balls[n].x, balls[n].y, Stylus.X, Stylus.Y); 
   
   balls[n].vx += ((3+balls[n].type)*PA_Cos(angle))>>1;
   balls[n].vy += ((3+balls[n].type)*PA_Sin(angle))>>1; 
	balls[n].vx -= balls[n].vx>>7;
	balls[n].vy -= balls[n].vy>>7;
	   
   balls[n].fx += balls[n].vx>>6;
   balls[n].fy -= balls[n].vy>>6;
   
   // Positions normales
	balls[n].x = balls[n].fx>>8;
	balls[n].y = balls[n].fy>>8;
	
//	PA_OutputText(1, 0, i, "%d %d    ", balls[n].x, balls[n].y);
	
	if(PA_Distance(Stylus.X, Stylus.Y, balls[n].x, balls[n].y) < 4*4){ // Si touche, on le reballe !
	   lost = 1; // Perdu !			   
	   return 0; // Refaire ce numro
	}
	else{
	   // Tester les collisions...
	   u8 collision = 0;
	   u8 j;
	   for(j = 0; j < ncarres; j++){
	      if((balls[n].x > carres[j].x -10)&&(balls[n].x < carres[j].x +10)
	      	&&(balls[n].y > carres[j].y -10)&&(balls[n].y < carres[j].y +10)){ // Colljsjon !
	      	   collision = 1;
	      }  
	   }   
			
		if(collision){
			nballs--;
		   nlibre[nballs] = n; // On remet dans le pool...
		   
		   nball[i] = nball[nballs]; // On met  la place le dernier...
		   pa_3dsprites[n].Alive = 0;	 
			
			combo++;
/*		//	for(y = 191-(combo-1)*4; y > 191-(combo)*4; y--){
			for(y = 0; y > (combo)*4; y++){
			   for(x = 0; x < 8; x++){
			      PA_Put8bitPixel(1, x, y, 255);
			      PA_Put8bitPixel(1, 255-x, y, 255);
			   }
			}	
				   */
			  
			score+=combo;
			combodown = COMBOTIME;
			
			u8 temp;
			for(temp = 0; temp < 32; temp++) Ajouterspark(balls[n].type, temp&15, balls[n].x, balls[n].y); // Faire sauter !
		   return -1; // Refaire ce numro			   			
		}			 
		else{     
		   
		   // Si visible, on affiche normalement...
		   if(((balls[n].x > -4)&&(balls[n].x < 256+4)&&(balls[n].y > -4)&&(balls[n].y < 192+4))){
			   PA_3DSetSpriteTex(n, ballgfx[0][balls[n].type]);
			   PA_3DSetSpriteXY(n, balls[n].x, balls[n].y); // Afficher...	
				PA_3DSetSpriteRotate(n, 0);	      
		   }   
		   else{ // Sinon on va afficher une flche  la place :p
	   		angle = PA_GetAngle(128, 96, balls[n].x, balls[n].y); 
	   
			   s32 x = balls[n].fx; 
			   s32 y = balls[n].fy; 
	   
			   while(!((x > 0)&&(x < (256<<8))&&(y > 0)&&(y < (192<<8)))){
			      x -= PA_Cos(angle);
			      y += PA_Sin(angle);      
			   }   
			   
			   x = x>>8; y = y>>8;
			   
			   if(y < 5) y = 5;
			   else if(y > 191-5) y = 191-5;
			   if(x < 5) x = 5;
			   else if(x > 255-5) x = 255-5;
			   			   
			   PA_3DSetSpriteTex(n, ballgfx[1][balls[n].type]);
			   PA_3DSetSpriteXY(n, x, y); // Afficher...	
				PA_3DSetSpriteRotate(n, angle);			   		      
		      
		      
		   }   
		   


		}  
	}		 
	
	return 0;
}   


void AjouterBall(void){
   
   if(nballs == 100) return; // On ne fait rien
   u8 n = nlibre[nballs]; // Rcuprer un slot disponible
   nball[nballs] = n;
   

   
   // Position alatoire pour le nouveau ball...
   u16 angle = PA_Rand()&511;
   
   balls[n].x = 128+((PA_Cos(angle)*170)>>8); 
   balls[n].y = 96-((PA_Sin(angle)*170)>>8); 
   
   if(balls[n].y < -8) balls[n].y = -8;
   else if(balls[n].y > 192+8) balls[n].y = 192+8;
   if(balls[n].x < -8) balls[n].x = -8;
   else if(balls[n].x > 256+8) balls[n].x = 256+8;   
   
   balls[n].vx = 0; 
   balls[n].vy = 0; 
   
   balls[n].type = PA_Rand()%3; 
   
   balls[n].fx = balls[n].x<<8;		balls[n].fy = balls[n].y<<8; // Fixed point...
   PA_3DCreateSpriteFromTex(n, ballgfx[0][balls[n].type], 8, 8, 0, 300, 300); // Dehors
   nballs++;
}   


// Function: main()
int main(int argc, char ** argv)
{
	PA_Init();    // Initializes PA_Lib
	PA_InitVBL(); // Initializes a standard VBL
	
	PA_Init3D();
	PA_Reset3DSprites();
	PA_Init8bitBg(1, 3); 
	PA_InitText(1, 0);
	PA_SetBgColor(0, PA_RGB(204>>3, 204>>3, 204>>3)); 
	
	PA_SetBgPalCol(1, 255, 0);
	
	PA_Load3DSpritePal(0, (void*)all_Pal);	
	
	carregfx = PA_3DCreateTex((void*)carre_Texture, 16, 16, TEX_256COL);
	sparkgfx = PA_3DCreateTex((void*)spark_Texture, 8, 8, TEX_256COL);
	
	InitSparks();
	
	s16 i, j;
	for(i = 0; i < 3; i++){
	   ballgfx[0][i] = PA_3DCreateTex((void*)(balls_Texture+8*16*i), 8, 8, TEX_256COL);
	   ballgfx[1][i] = PA_3DCreateTex((void*)(balls_Texture+8*8+8*16*i), 8, 8, TEX_256COL);	   
	}   

	while(1){
		


		
		PA_OutputText(1, 4, 8, "Touch Screen to start");
		combo = 0; combodown = 0;
		PA_WaitFor(Stylus.Newpress);
		PA_OutputText(1, 4, 8, "                       ");		
	
		for(i = 0; i < 1024; i++) pa_3dsprites[i].Alive = 0;
		for(j = 0; j < MAX_BALLS; j++) {
		   nlibre[j] = j;
		}   
	
		
		
		nballs = 0;
		ncarres = 0;
		lost = 0;
		level = 0;


		score = 0;
		AjouterCarre();
		
		while(!lost){
		   
			level++;
			PA_OutputText(1, 4, 4, "Level : %02d", level);
			
		   if((level&7) == 0) AjouterCarre(); // Tous les 4 levels ajouter un obstacle			
			for(i = 0; i < level; i++)	 AjouterBall(); // Ajouter 1 ball  chaque VBL ^^
		
			// Infinite loop to keep the program running
			while ((!lost)&&(nballs))
			{
			   if(combodown) combodown--;
			   else if(combo){
			      combo--;
			/*      s16 x, y;
					for(y = 191-(combo-1)*4; y > 191-(combo)*4; y--){
					   for(x = 0; x < 8; x++){
					  //    PA_Put8bitPixel(1, x, y, 0);
					   //   PA_Put8bitPixel(1, 255-x, y, 0);
					   }
					}	*/
			      combodown = COMBOTIME;
			      
			   }   
			  	for(i = 0; i < ncarres; i++){
			  	   if(carres[i].width < 16) {
					   carres[i].width++;
	   				PA_3DSetSpriteWidthHeight(128+i, carres[i].width, carres[i].width);
	   			}		
					else if(PA_3DSpriteTouched(128+i)) lost = 1; // PERDU !	
			  	}   
			   
			   for(i = 0; i < nballs; i++) i+= DeplacerBall(i);
			   for(i = 0; i < nballs; i++) i+= DeplacerBall(i); // En 2 fois pour plus de prcision !
			   for(i = 0; i < nsparks; i++) i+= Deplacerspark(i);
			   PA_OutputText(1, 0, 0, "%d  ", nsparks);
			   
			   PA_OutputText(1, 4, 6, "Score : %d         ", score);
			   PA_OutputText(1, 4, 8, "Combo : %d         ", combo);
			   PA_3DProcess();
				PA_WaitForVBL();
				UpdateColor();
			}
		}			
	}		
	
	return 0;
} // End of main()
