// Includes
#include <PA9.h>       // Include for PA_Lib

#include "gfx/all_gfx.h"

typedef struct{
   s32 fx, fy, vx, vy;
} spark_type;

spark_type sparks[768]; // 100 max
u16 nspark[768];
u16 nfree[768];
u16 nsparks;
extern u16 sparkgfx;


u8 sparkimg[8*8] = {}; // Buffer
u8 sparktex[3][16];
u16 sparkangle[16]; // En fonction du morceau, une direction diffrente...



s8 Deplacerspark(u16 i){
   u16 n = nspark[i];
   

   sparks[n].fx += sparks[n].vx;
   sparks[n].fy += sparks[n].vy;
	
	if((sparks[n].fx < -(8<<8)||(sparks[n].fx > (256+8)<<8)||(sparks[n].fy < -(8<<8))||(sparks[n].fy > (192+8)<<8))){ // Si touche, on le resparke !
		nsparks--;
	   nfree[nsparks] = n; // On remet dans le pool...
	   
	   nspark[i] = nspark[nsparks]; // On met  la place le dernier...
	   pa_3dsprites[n+256].Alive = 0;
			   
	   return -1; // Refaire ce numro
	}
	else{     
	   PA_3DSetSpriteXY(n+256, (sparks[n].fx>>8)-8, (sparks[n].fy>>8)-8); // Afficher...
	}   
	
	return 0;
}   


void Ajouterspark(u8 color, u8 number, s16 x, s16 y){
   
   if(nsparks == 768) return; // On ne fait rien
   u8 n = nfree[nsparks]; // Rcuprer un slot disponible
   nspark[nsparks] = n;
   
   x += number&3;   y += number>>2;
   sparks[n].fx = x<<8; 
   sparks[n].fy = y<<8;
   s32 angle = sparkangle[number] + (PA_Rand()&63); // Direction au hasard
   
   s32 speed = 256+(PA_Rand()&511); // Vitesse alatoire de 2  5
   sparks[n].vx = (PA_Cos(angle)*speed)>>8;
   sparks[n].vy = -(PA_Sin(angle)*speed)>>8;
   
//   sparks[n].fx += sparks[n].vx*temp;	   sparks[n].fy += sparks[n].vy*temp;	
   PA_3DCreateSpriteFromTex(n+256, sparktex[color][number], 8, 8, 0, sparks[n].fx>>8, sparks[n].fy>>8);
//   PA_3DSetSpriteRotate(n+256, angle);
   nsparks++;
}   


// Function: main()
void InitSparks(void)
{
	u16 i;
	for(i = 0; i < 768; i++) nfree[i] = i;
	nsparks = 0;
	
	u8 number;
	// Initialiser les diffrents morceaux...
	u16 x, y;
	for(y = 0; y < 8; y+=2){
	   for(x = 0; x < 8; x+= 2){
	      number = (x>>1)+(y>>1)*4;
	      for(i = 0; i < 3; i++){
	         sparkimg[0] = balls_Texture[i*8*8*2+x+y*8];
	         sparkimg[1] = balls_Texture[i*8*8*2+x+1+y*8];
	         sparkimg[8] = balls_Texture[i*8*8*2+x+8+y*8];
	         sparkimg[9] = balls_Texture[i*8*8*2+x+9+y*8];
				// Charger comme nouvelle texture
				sparktex[i][number] = PA_3DCreateTex((void*)sparkimg, 8, 8, TEX_256COL);					         
	      }   
	      sparkangle[number] = PA_GetAngle(3<<8, 3<<8, x<<8, y<<8)-32; // Direction  prendre (en gros)
	   }
	}		   

} // End of main()
